.386

.MODEL FLAT,STDCALL

OPTION CASEMAP:NONE

WinMain PROTO :DWORD,:DWORD,:DWORD,:DWORD
TimerProc PROTO :DWORD,:DWORD,:DWORD,:DWORD
dwtoa PROTO :DWORD,:DWORD

Include Fire.inc
Include fireGDI+.inc

.CODE
Start:
	Invoke GetModuleHandle, NULL
	MOV hInstance,EAX
;	Invoke GetCommandLine
;	MOV CommandLine, EAX
	Invoke WinMain, hInstance, NULL, CommandLine, SW_SHOWDEFAULT
	Invoke ExitProcess,EAX
	
WinMain Proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
Local wc:WNDCLASSEX
Local msg:MSG
Local hwnd:HWND

	Invoke GetSystemMetrics, SM_CXSCREEN
	MOV Scr_SizeX,EAX
	SHR EAX,1
	MOV Win_SizeX,EAX
	Invoke GetSystemMetrics, SM_CYSCREEN
	MOV	Scr_SizeY,EAX
	SHR EAX,1
	MOV Win_SizeY,EAX
	; Initialize GDIplus
	Invoke GdiplusStartup,ADDR hGDIplus,ADDR GdiPlusSI,NULL
	.IF eax != 0
		Invoke MessageBox, NULL, ADDR szGDIpInitFail, Offset szAppName, MB_OK OR MB_ICONERROR
		RET
	.ENDIF
		
	MOV wc.cbSize, SizeOf WNDCLASSEX
	MOV wc.style, CS_HREDRAW or CS_VREDRAW or CS_OWNDC 
	MOV wc.lpfnWndProc, Offset WndProc
	MOV wc.cbClsExtra,NULL
	MOV wc.cbWndExtra,NULL
	PUSH hInst
	POP wc.hInstance
	MOV wc.hbrBackground, COLOR_WINDOWTEXT;+1
	MOV wc.lpszMenuName, NULL
	MOV wc.lpszClassName, Offset ClassName
	Invoke LoadIcon, NULL, IDI_WINLOGO	
	MOV wc.hIcon,EAX
	MOV wc.hIconSm,0
	Invoke LoadCursor, NULL, IDC_ARROW
	MOV wc.hCursor,EAX
	Invoke RegisterClassEx, addr wc
	Invoke LoadMenu, hInst, Offset MenuName
	MOV hMenu,EAX
	Invoke CreateWindowEx, WS_EX_CLIENTEDGE, ADDR ClassName, ADDR szAppName,\
           WS_OVERLAPPEDWINDOW, CW_USEDEFAULT,\
           CW_USEDEFAULT, Win_SizeX, 300, NULL, hMenu,\
           hInst, NULL
	MOV hwnd,EAX
	Invoke ShowWindow, hwnd, SW_SHOWNORMAL
	Invoke UpdateWindow, hwnd
	.While TRUE
		Invoke GetMessage, ADDR msg, NULL, 0, 0
		.Break .IF (!EAX)
		Invoke TranslateMessage, ADDR msg
		Invoke DispatchMessage, ADDR msg
	.EndW
	MOV EAX, msg.wParam
	RET
WinMain ENDP

WndProc Proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
;LOCAL hdc:HDC 
LOCAL ps:PAINTSTRUCT 

	.IF uMsg==WM_DESTROY
		; kill the timer
		Invoke KillTimer,hWnd,TimerID
		; Shutdown GDIplus.dll
		.IF hGDIplus != 0
			Invoke GdiplusShutdown,hGDIplus
		.ENDIF
		; free allocated memory
		.IF ptrColTable != 0
			Invoke LocalFree,ptrColTable
		.ENDIF
		.IF hLColMem != 0						; check if we have a valid handle
			Invoke LocalFree,hLColMem
		.ENDIF
		Invoke PostQuitMessage, NULL
	.ELSEIF uMsg == WM_CREATE
		; Setup timer
		Invoke SetTimer,hWnd,1,20,ADDR TimerProc
		mov TimerID,eax
		; Allocate mem for colortable
		Invoke LocalAlloc,LMEM_FIXED OR LMEM_ZEROINIT,1024	; LMEM_FIXED: hMem == ptrMem
		.IF eax != NULL
			mov	ptrColTable,eax
			Invoke initColorTable
			;Invoke write_to_disk, ADDR szWtFileName, ptrColTable, 1024
		.ELSE
			Invoke DestroyWindow,hWnd
		.ENDIF
	.ELSEIF uMsg==WM_COMMAND
		MOV EAX,wParam
		.IF AX==IDM_HELP_ABOUT
			Invoke MessageBox, NULL,ADDR szHelpAbout, Offset szAppName, MB_OK
		.ELSE
			Invoke DestroyWindow, hWnd
		.ENDIF
	.ELSE
		Invoke DefWindowProc, hWnd, uMsg, wParam, lParam
		RET
	.ENDIF
	XOR EAX,EAX
	RET
WndProc ENDP

END Start